2024-06-17  Michael Bell <michael.bell@web.de>
  * Released 0.11.10
  * Removed a few unused variables which gcc reported during building
    with -Wall compiler option. A notable case was in function
    decode_wv_datetime where a memory allocation failure was ignored
    (pull request #92 by Petr Pisar).
  * Added workaround for buggy FindEXPAT in cmake 3.27-3.29.
  * Enabled --output-on-failure in GitHub runner config of ctest.
  * Removed proprietary Testing.cmake.
  * Updated the cmake package information by replacing the find module with
    proper cmake config and version files.
  * Removed all cmake find modules of third party dependencies.
  * Replaced proprietary FindCheck.cmake with standard usage of PkgConfig.

2024-06-07  Michael Bell <michael.bell@web.de>
  * Released 0.11.9
  * Removed assert in function wbxml_tree_clb_xml_end_element of
    wbxml_tree_clb_xml.c. The function had already the correct error handling
    implemented. The library no longer crashes but returns an error. The usage
    of assert.h was removed from wbxml_tree_clb_xml.c.
  * Fixed SIGSEGV during parsing of malformed WV document in wbxml_parser.c.
    (SIGSEGV from Simon Koski & Alex Zhang)
  * Fixed the handling of a wrong Unicode character in the function
    parse_entity of wbxml_parser.c. The library no longer crashes but returns
    an error. Therefore, a new error was defined in wbxml_errors.h. The usage
    of assert.h was removed from wbxml_parser.c.
    (SIGABRT from Simon Koski & Alex Zhang)
  * Added missing NULL pointer check in function decode_opaque_content of
    wbxml_parser.c (SIGSEGV from Simon Koski & Alex Zhang).
  * Added a directory for and with fuzz tests which crash(ed) the library.
    (Thanks goes to Simon Koski & Alex Zhang for the tests.)
  * Modify wbxml_getopt return opt type to int
  * Check for normalize_xml.pl failures in the tests (pull request #84).

2022-02-28  Michael Bell <michael.bell@web.de>
  * Released 0.11.8
  * Changed location of releases to GitHub only in README.
  * Change the default internal namespace separator from the colon to the pipe
    (issue #76 from Sebastian Pipping, fixed in pull request #78 from Slávek Banko).
    This solves compatibility with libexpat >= 2.4.5 after fix the security
    problem CVE-2022-25236.
  * Removed copy of Expat in macosx directory (issue #77).
  * Migrated from Travis CI to GitHub actions for testing.

2020-04-15  Michael Bell <michael.bell@web.de>
  * Released 0.11.7
  * Added WBXML_INSTALL_FULL_HEADERS cmake flag to expose internal API
    headers; changes version for compatibility (e.g. 2.6.1 -> 20601.0.0)
    (pull request #67 from David Llewellyn-Jones)
  * Link to libexpat correctly (private). Therefore the tools wbxml2xml
    and xml2wbxml do no longer link directly to libexpat.
    (pull request #65 from Peter Keresztes Schmidt)
  * During build use headers which come with source code and not the
    installed headers. (pull request #66 from David Llewellyn-Jones)
  * Fixed several memory leaks and leak-sanitizer issues.
    (pull requests #61, #62, #63 and #64 from Gaurav Gupta)

2017-08-15  Michael Bell <michael.bell@web.de>
  * Released 0.11.6
  * Fixed/changed the encoding of element Content in CodePage
    AirSyncBase (0x11) to WBXML_BINARY_OPTION for Microsoft ActiveSync.
    This element is used when the clients send a request to save a draft
    email. An example can be found in:
      http://interoperability.blob.core.windows.net/files/MS-ASEMAIL/[MS-ASEMAIL].pdf
    (4.4 Adding a Draft Email with Attachments).
    Reference:
      https://msdn.microsoft.com/en-us/library/mt563406%28v=exchg.80%29.aspx
    (issue #58 from Thomas Führer)
  * Added a testcase for Microsoft ActiveSync EAS Provisioning
    (clarifies issue #56).

2017-02-12  Michael Bell <michael.bell@web.de>
  * Released 0.11.5
  * Fixed ActiveSync element data of code pages ResolveRecipients and
    GAL (issue #52 from Thomas Führer, fixed in pull request #53).
  * Added support for MacOS X to Travis CI environment.
  * Added support for ccache (pull request #44 from Gaurav Gupta).
  * Fixed some memory leaks (pull requests #43 and #45 from Renu Tyagi).
  * Added definitions of ActiveSync protocoll v16.0
    (pull request #32 from Gil Hartmann).
  * Avoid malloc typecasts (pull requests #31, #33, #34, #35, #36,
    #37, #38, #39 and #40 from Gaurav Gupta).
  * Added support for automated testing with travis-ci.org
  * Fixed memory leak in function wbxml_strtbl_collect_words
    of wbxml_encoder (pull request #21 from Gaurav Gupta).
  * Fixed memory leak in function wbxml_strtbl_check_references
    of wbxml_encoder (pull request #20 from Gaurav Gupta).
  * Added support to build a static library
    (issue #22 and pull requests #23, #24, #25, #26 and #27
    from Gaurav Gupta).
  * If pkg-config is used then use the provided ldflags
    (pull request #19 from Jeroen Dekkers).

2015-04-09  Michael Bell <michael.bell@web.de>
  * Released 0.11.4
  * Get rid of the useless file MANIFEST (cmake don't need it).
  * Fixed CMakeLists.txt to get rid of the files AUTHORS and NEWS
    (GitHub issue #17).
  * If there is no CHECK support then the API tests must not be
    executed (GitHub issue #18).
  * Removed AUTHORS because the more complete information is in
    the file THANKS.
  * Removed NEWS because the content is already in ChangeLog.
  * Fixed RELEASE instructions for GitHub.

2015-04-07  Michael Bell <michael.bell@web.de>
  * Released 0.11.3
  * Migrated the sources to github
  * Replaced the references to the degraded OpenSync infrastructure
  * Introduced a single test directory.
  * Added the first test suite for a private API - src/wbxml_lists.h.
    This includes a frame work for such test suites.
  * Added a sanity check to make some tools happy in
    wbxml_strtbl_collect_strings in src/wbxml_encoder.c.
    The patch was supplied by Gaurav Gupta from Samsung.
  * Fixed a memory leak of wbxml_tree_clb_xml_end_element in
    src/wbxml_tree_clb_xml.c.
    The patch was supplied by Gaurav Gupta from Samsung.
  * Added some sanity checks to detect the wrong usage of
    wbxml_fill_header in src/wbxml_encoder.c.
    The patch was supplied by Gaurav Gupta from Samsung.
  * The code of the function wbxml_tree_clb_xml_end_element to handle
    binary tags used variables which were only defined if the SyncML
    code is enabled. The file wbxml_tree_clb_xml.c was fixed
    (ticket #85).

2012-07-20  Michael Bell <michael.bell@web.de>
  * Released 0.11.2
  * libwbxml2 only depends on expat. It does not depend on libxml2.
    The pkgconfig file and the cmake module were fixed.
  * FindLibWbxml2.cmake is installed during "make install" (ticket #83).
    The external cmake modules are now included at cmake/modules
    because the cmake directory includes a CMakeLists.txt.
  * Removed outdated test/test_parser.c (ticket #82).

2012-05-25  Michael Bell <michael.bell@web.de>
  * Released 0.11.1
  * Fixed performance problem during the generation of XML documents.
    Committed the original patch from ticket #81.
    The patch was supplied by Conrad Irwin.
  * The parameter malloc_block of the function wbxml_buffer_create_real
    is only used now for the initial memory allocation. The patch for
    ticket #80 introduced a more agressive algorithm for memory
    re-allocation to support big files.
  * Fixed performance problem during the parsing of XML documents.
    Committed the original patch from ticket #80.
    The patch was supplied by Conrad Irwin.
  * Extract node breaks (null'ed) the previous node link to a next node
    (too early cleanup in wbxml_tree_extract_node of wbxml_tree.c).
    The patch was supplied by Mark Ostrer from Websense (ticket #79).
  * Added a trailing newline to the files THANKS and TODO (ticket #77).
  * The tool xml2wbxml is now covered by LGPL v2.1 (or any later).
    Petr Pisar discovered that wbxml2xml and xml2wbxml used different
    licences.  This was a mistake. Aymerick Jehanne and Michael Bell
    (the copyright holders) agreed on using LGPL as licence.
    (ticket #76)

2011-08-06  Michael Bell <michael.bell@web.de>
  * Released 0.11.0
  * This is an exact copy of 0.11.beta6.

2011-06-06  Michael Bell <michael.bell@web.de>
  * Released 0.11.beta6
  * Fixed handling of base64 encoded data in elements which are flagged
    as WBXML_TAG_OPTION_BINARY. The base64 encoded data is only decoded
    when all data is present (ticket #75).
  * Added two new internal functions for the encoding and decoding of
    base64 in a buffer (including cleanup of wbxml_encoder.c). The
    decoder function supports formatted base64 strings too
    (e.g. blanks, tabs and newlines).
  * Added test for ticket #75 (formatted base64 string in binary tag).
  * Failing tests do no longer remove their temporary data.
  * Fixed wrong opaque conversion from WBXML to XML (never normalize
    opaque/binary data).
  * Added a new error code for the base64 decoder only. The decoder
    used the same error code and message like the encoder until now.
  * Added flag WBXML_TAG_OPTION_BINARY to tag MIME of ActiveSync code
    page CompseMail:.
  * Fixed otion -a of xml2wbxml (-a was not allowed as option).
  * Added two tests for ActiveSync command SendMail.
  * Fixed usage of strncasecmp and location of a variable definition
    (changes from ticket #73).
    This fixes some compiler errors from MS VisualStudio C++ 2010.
    The patch was supplied by Boaz Yaniv.

2011-04-27  Michael Bell <michael.bell@web.de>
  * Released 0.11.beta5
  * Fixed an inconsistency in the naming conventions of the new
    functions.

2011-04-19  Michael Bell <michael.bell@web.de>
  * Released 0.11.beta4
  * Added option -a to xml2wbxml (anonymous format). The public ID is
    set to unknown and the DTD is not included.

2011-04-14  Michael Bell <michael.bell@web.de>
  * Released 0.11.beta3
  * Some defines were added again to support the old libwbxml 0.9.2
    interface. This fixes mainly some names of parameter types.
    You can compile libsyncml like follows:
    CFLAGS="-I/usr/local/include/libwbxml-1.0/wbxml" cmake . -B/tmp/build/libsyncml
  * If the XML root element must be used to identify the WBXML language
    then the name space is scanned before the root element itself.
    All SyncML versions use the same root element. Nevertheless it is
    better to set the document type correctly.
  * Fixed literal tag encoding. The element name and not the namespace
    must be encoded.
  * Added ActiveSync support with Microsoft's original namespaces.

2011-01-25  Michael Bell <michael.bell@web.de>
  * Released 0.11.beta2
  * The WBXML converter interface is now more robust in terms of new
    parameters and binary downward compatibility.
  * Added workaround for Nokia bug. Some Nokia software does not only
    encode the name space in the public ID. It also stores the name
    space in the root element as an attribute with an attribute name
    as literal reference zero but without a string table and the name
    space as an inline string.
    (Example: 04 00 03 string 00 => LITERAL index[0] STR_I string \0)
  * Every enum element has a fixed number.
  * Fixed SO-naming.

2011-01-20  Michael Bell <michael.bell@web.de>
  * Released 0.11.beta1
  * Changed the location of the header files including the installation
    path to support several versions of the library at the same host
  * Header files are installed to separate directory wbxml/
  * Reduced API (removed 14 header files from installation)
  * Removed unused parameter node from parse_cdata in wbxml_encoder.c.
    (ticket #43)
  * Fixed unused parameter warnings from expat callbacks.
    (ticket #47, #48 and #49)
  * Fixed wrong detection of WBXML language table list end.
    (ticket #44 and #45)
  * Added support for opaque tokens (e.g. byte arrays from Microsoft
    ActiveSync, code page Email2 ConversationId and ConversationIndex)
    (ticket #55). The original patch was supplied by Amnon Aaronsohn.
  * Added new parameter -c for character set specification to wbxml2xml
    (ticket #52)
  * Added support for setting the character set in the transport
    meta-information. This means that it is possible to set the
    character set via the interface. Please note that you cannot
    enforce a character set. (ticket #52)

2011-01-08  Michael Bell <michael.bell@web.de>
  * Released 0.10.9
  * Added correct default behaviour to parse_charset. If no character
    set is specified in a WBXML document then UTF-8 is assumed until
    there is another specification in the transport meta-information.
    (ticket #52)
  * Fixed integer overflow in opaque data parsing (ticket #54).
    The patch was supplied by Amnon Aaronsohn.
  * Fixed iconv support (ticket #52)
  * Added several tokens for Microsoft ActiveSync v14.0 revision 8.0
    (ticket #53). The patch was supplied by Amnon Aaronsohn.
  * Fixed wrong WBXML table token for OMA DM DDF (ticket #51)
  * Fixed unsigned integer overflow (patch from ticket #41)
    The overflow causes crashs or wrong wbxml messages.
  * Fixed locations of variable definitions and replaced strtoull by
    strtoul (changes from ticket #42 and #50).
    This fixes some compiler errors from MS VisualStudio 2008 and 9.0.
  * Added support for recursion in wbxml_tree_node_elt_get_from_name
    (ticket #46)

2010-03-29  Michael Bell <michael.bell@web.de>
  * Released 0.10.8
  * Removed OMA DM tests because the OMA did not grant a permission
    for the inclusion (ticket #36).
  * Added a fix for the broken vFormat handling in the SyncML
    specification. All LFs are replaced by CRLFs in every vFormat
    object inside a SyncML message (ticket #38).
  * Added Nokia ConML support (ticket #35).
    There is no public documentation available from Nokia. The
    transformation tables were created from sniffed WBXML documents.
    The patch was supplied by Anton D. Kachalov.

2009-05-12  Michael Bell <michael.bell@web.de>
  * Released 0.10.7
  * Fixed a Debian MIPS port build issue (ticket #34)
    If the operating system environment has a built-in getopt
    implementation then the cmake environment disables the internal
    implementation of libwbxml and uses the getopt function of the
    operating system. This avoids clashes with variables which are
    declared extern and explicit but already exists in the default
    POSIX header files (e.g. optopt).

2009-04-24  Michael Bell <michael.bell@web.de>
  * Released 0.10.6
  * Extended (updated) tables for Microsoft AirSync
    (The patch was supplied by Ossi Jormakka from Ixonos Plc.)
  * Expat splits &lt;html&gt; into three separate text nodes.
    Therefore it is necessary to scan for splitted text nodes
    and merge them into a single consistent text node. 
  * Normalize encoding with normalize_xml.pl 
  * Fixed bashisms in launchTest.sh
  * Fixed Sun Studio CC and GCC warnings.
  * Fixed Testing.cmake to not set GCC specific compiler and linker
    flags for other compilers.
  * Fixed race condition in WV datetime opaque encoding

2009-03-30  Michael Bell <michael.bell@web.de>
  * Released 0.10.5
  * Fixed library installation path for win32 (ticket #31)
    (The patch was supplied by Jeremy Laine.)

2009-03-09  Michael Bell <michael.bell@web.de>
  * Released 0.10.4
  * Fixed the byte order of the WV datetime opaque encoding (the bytes
    were written in the reversed order)
  * Fixed the time zone byte handling in the WV datetime opaque encoding
    (e.g. A means UTC+1, Z must be 0x5a) (ticket #30)
  * Added correct timezone handling for WV datetime opaque parser
  * Added support for WV datetime inline encoding. All timestamps which
    use the full ISO style like 2001-09-12T13:09:12+02:00 are encoded
    as inline strings. This style is strongly recommended because time
    zones like UTC+09:30 of Darwin in Australia are supported too.
    (ticket #30)
  * Added support for an EXPECTED value to the XML normalization script

2009-02-17  Michael Bell <michael.bell@web.de>
  * Released 0.10.3
  * Added support for SourceParent in SyncML 1.1.
    This is a proprietary extension to support things like the SMS and
    bookmark synchronization of Nokia.

2009-02-06  Michael Bell <michael.bell@web.de>
  * Released 0.10.2
  * Added support for OMA DM DDF 1.2 (ticket #7).
  * DRMREL 1.0 test cases were disabled because of the poor
    specification (e.g. hard coded names for XML namespaces and
    definition of such namespaces as (WB)XML attributes).
  * The generated XML documents of the most tests (conversion from XML
    to WBXML back to XML) are compared with the original documents.
    Only special tests are not covered (e.g. hexadecimal number
    conversion, SyncML CDATA usage). 
  * If there is no PUBLIC ID then DOCTYPE must include PUBLIC "" or
    SYSTEM. libwbxml always adds SYSTEM in this case.
  * Fixed datetime support for Wireless Village (ticket #27).
  * Extension tokens must not be replaced within normal text data
    (ticket #26).
  * Ticket #13 was rejected because the mentioned specification is only
    a today outdated OMA change request. Perhaps a new specification
    must be implemented in case of a new request. 
  * Created a script to normalize XML documents.
  * The getopt implementation was replaced because of a potential
    license issue. This fixed a Solaris build issue too (ticket #25).

2009-01-06  Michael Bell <michael.bell@web.de>
  * Released 0.10.1
  * Removed a useless buffer which only creates a memory leak.
  * The installation of the documentation can be disabled.
  * LIBDATA_INSTALL_DIR was introduced (used by pkgconfig). 
  * All tests are executed as standalone tests to get more
    detailed informations if a test fails.
  * The timezone of the nightly build-time was fixed.

2008-12-05  Michael Bell <michael.bell@web.de>
  * Released 0.10.0
  * Fixed ticket #14 with patch from ticket
    (hexadecimal integer support for Wireless-Village)
  * Added datetime encoding support for Wireless-Village.
    (The encoder can tolerate missing seconds like in the tests.)
  * Tests were integrated and can be used via make test.
  * Build system switched to cmake from GNU autotools.
  * Size changed to MaxSize in OMA DS 1.2 DevInf
  * Fixed a couple of issues with SyncML, by Michael Bell
  * Fixed segfault in wbxml_encoder.c
      - Thanks Stijn van Drongelen
  * Added Sax like entity parsing
  * Miscellaneous build fixes and anonymous document support
  * Namespaces support
  * Some more cleanup and bug fixes

2008-11-21  Aymerick Jehanne <aymerick@jehanne.org>
  * New release: 0.9.3
  * Project cleanup.

2006-07-10  Aymerick Jehanne <aymerick@jehanne.org>
  * New release: 0.9.2
  * Finally applied fixes from OpenSync project and Debian libwbxml package
  * Added XCode project for MacOS X
  * Added Microsoft AirSync support
  * Some more cleanup and bug fixes
  * Windows and Symbian projects files are NOT up to date at all. Searching for mainteners.

2005-12-19  Aymerick Jehanne <aymerick@jehanne.org>
  * wbxml_tree.c: Fixed wbxml_tree_node_get_syncml_data_type().

2005-11-28  Aymerick Jehanne <aymerick@jehanne.org>
  * SyncML 1.2 support
  * Improved WBXMLTree API
  * New encoder 'flow mode'
  * Back to LGPL licence

2005-05-23  Aymerick Jehanne <aymerick@jehanne.org>
  * wbxml_tables.c: Added the 'WBXML_SUPPORT_PROV_11' flag to activate
    OMA PROV 1.1 tables. There is no new Public ID defined to OMA PROV 1.1.
    I don't know how to handle this, so for the moment I apply the OMA PROV 1.1
    tables modifications directly into OMA PROV 1.0 tables.

2005-04-01  Aymerick Jehanne <aymerick@jehanne.org>
  * wbxml_parser.c: Corrected a bug when Public ID is in string table.
    Handle phones that don't end string table with a terminating NULL char.
    Removed some potential memory leaks.

2005-03-29  Aymerick Jehanne <aymerick@jehanne.org>
  * wbxml_tree.[h|c]: Added wbxml_tree_node_have_child_elt()
  * wbxml_encoder.c: Added WBXML_ENCODER_XML_NO_EMPTY_ELT_INDENT
    to disable indent of elements that do not have child elements, for
    a more readable XML generation. This flag should be replaced by
    a configuration var later.

2005-03-20  Aymerick Jehanne <aymerick@jehanne.org>
  * Work on Symbian port / Start of SyncML wrapper / Some cleanup

2005-03-16  Aymerick Jehanne <aymerick@jehanne.org>
  * src/wbxml_encoder.c: Do not generate string table for OTA Settings
    documents (thanks to Rasmus Lock Larsen).

2005-03-10  Aymerick Jehanne <aymerick@jehanne.org>
  * src/wbxml_tables.c: Changed 'NumberOfChanged' to 'NumberOfChanges'
    in SyncML table (thanks to Frank Sprague).

2005-03-01  Aymerick Jehanne <aymerick@jehanne.org>
  * doc/: Removed deprecated files.
  * web/: Removed folder.

2005-02-24  Aymerick Jehanne <aymerick@jehanne.org>
  * src/wbxml_parser.c: Fixed bug [1080489] (thanks to Rasmus Lock Larsen)
  * src/wbxml_encoder.c: Added a 'WBXML_ENCODER_XML_GEN_EMPTY_ELT' flag
    to enable generation of '<foo />' instead of '<foo></foo>'. This flag
    should be replace to a configuration var later.

2005-02-23  Aymerick Jehanne <aymerick@jehanne.org>
  * src/wbxml_tree.[h|c] : Added wbxml_tree_node_destroy_all().

2005-02-22  Aymerick Jehanne <aymerick@jehanne.org>
  * src/wbxml_tree.[h|c] : Added wbxml_tree_extract_node().

2005-02-17  Aymerick Jehanne <aymerick@jehanne.org>
  * src/wbxml.h, src/wbxml_conv.[h|c], src/wbxml_elt.[h|c],
    src/wbxml_encoder.c, src/wbxml_tree.[h|c],
    src/wbxml_tree_clb_wbxml.c, src/wbxml_tree_clb_xml.c,
    tools/wbxml2xml_tool.c, tools/xml2wbxml_tool.c : Work continue
    on new wbxml_tree.h interface
    
  * src/wbxml_buffers.h: typo correction

2005-02-17  Aymerick Jehanne <aymerick@jehanne.org>
  * src/wbxml_tree.c, src/wbxml_tree_clb_xml.c : Implemented
    wbxml_tree_add_elt()

2005-02-16  Aymerick Jehanne <aymerick@jehanne.org>
	* src/wbxml.h, src/wbxml_conv.[h|c], src/wbxml_elt.h,
	  src/wbxml_encoder.[h|c], src/wbxml_tables.[h|c],
	  src/wbxml_tree.[h|c], src/wbxml_tree_clb_wbxml.c,
	  src/wbxml_tree_clb_xml.c, tools/wbxml2xml_tool.c:
		- started to work on new wbxml_tree API
	    - refactored wbxml_tree.c and wbxml_conv.c
		- some typo fixes and code clean-up

2005-02-11  Aymerick Jehanne <aymerick@jehanne.org>
    * all files cleanup: replaced tabs by 4 spaces, and forced Unix
      files format
    * WV test suite fixes

2005-02-08  Aymerick Jehanne <aymerick@jehanne.org>
    * src/wbxml_conv.[h|c], src/wbxml_encoder.c,
      tools/wbxml2xml_tool.c, tools/xml2wbxml_tool.c : Renamed
      wbxml_conv_wbxml2xml() and wbxml_conv_xml2wbxml() functions,
      then added two macros to permit wbxml_conv.h interface
      backward compatibility
    * src/wbxml_encoder.c: Fixed a bug that produced non valid XML
      by not replacing '<' and '&' characters to their entity values

2005-02-02  Aymerick Jehanne <aymerick@jehanne.org>
    * src/wbxml_charset.c: clean-up
    * src/wbxml_tables.c: WV 1.2 - Reviewed tables to apply
      OMA-IMPS-WV-CSP_WBXML-V1_2-20040522-C.pdf

2005-02-01  Aymerick Jehanne <aymerick@jehanne.org>
    * Some files: Typo corrections
    * All files: Copyright update
    * Lot of files: First work on multiple charsets
      handling, using libiconv

2004-09-20  Aymerick Jehanne <aymerick@jehanne.org>
    * New release of wbxml2: 0.9.1

2004-09-20  Aymerick Jehanne <aymerick@jehanne.org>
    * src/wbxml_parser.c: Modified parse_content()
      to handle correctly a SyncML content generated
      by a Nokia 6600
    
2004-02-29  Aymerick Jehanne <aymerick@jehanne.org>
    * New release of wbxml2: 0.9.0
    
2004-02-28  Aymerick Jehanne <aymerick@jehanne.org>
    * src/wbxml_tables.h: Corrected WBXML Public Ids for
      SyncML 1.0 and DevInf 1.0 (hope, this is a good
      choice...)

2004-02-26  Aymerick Jehanne <aymerick@jehanne.org>
    * src/wbxml_parser.c: Initialize wbxml version
      to WBXML_VERSION_10 in parse_version() before
      parsing (thanks to Thomas Butter).
    * src/wbxml_parser.c: Added support for Altitude,
      Accuracy and Cpriority presence attributes 
      in decode_wv_content() (thanks to Erik).
    * src/wbxml_parser.c: Modified decode_wv_integer()
      to allow decoding of '0 length' integers
      (thanks to Erik) [Example: 'C3 80 00 01'].

2004-02-25  Aymerick Jehanne <aymerick@jehanne.org>
    * New license: GNU GPL
    * New website: http://libwbxml.aymerick.com

2004-01-13  Aymerick Jehanne <libwbxml@jehanne.org>
    * src/wbxml_encoder.c: Corrected CDATA encoding.
      Now CDATA is encoded into Opaque [to be tested
      with real phones]
    * src/wbxml_parser.c: Added debug info

2004-01-11  Aymerick Jehanne <libwbxml@jehanne.org>
    * Added Symbian Port
    * Added CDATA Support
    * src/wbxml_tables.h: Corrected WBXML Public Ids for
      SyncML 1.1 and DevInf 1.1 (Thanks to Miguel Coca)

2003-11-24  Aymerick Jehanne <libwbxml@jehanne.org>
    * New release of wbxml2: 0.8.2
      - This is the last release before moving to 
        'happycoders.net' framework
      - This is the last release under LGPL licence

2003-11-23  Aymerick Jehanne <libwbxml@jehanne.org>
    * src/wbxml_buffers.c: Corrected initializations.

2003-11-19  Aymerick Jehanne <libwbxml@jehanne.org>
    * src/wbxml_encoder.c: Patched xml_encode_text() for SyncML
      support. Thanks to Bo Lincoln.

2003-11-01  Aymerick Jehanne <libwbxml@jehanne.org>
    * src/wbxml_base64.[h|c]: Added base64 support.
    * testsuite/drmrel/: Added DRMREL 1.0 Test Suite.
    * Added support of <ds:KeyValue> for DRMREL 1.0 in Parser
      and Encoder.
    * Added Leak Tracker.
    * New release of wbxml2: 0.8.1

2003-10-28  Aymerick Jehanne <libwbxml@jehanne.org>
    * Moved WBXML Versions tokens to an Enumeration.
    * Added possibility to choose the WBXML Version when encoding
      to WBXML.

2003-10-20  Aymerick Jehanne <libwbxml@jehanne.org>
    * Lot of code fixes / clean-up
    * New release of wbxml2: 0.8.0

2003-10-18  Aymerick Jehanne <libwbxml@jehanne.org>
    * Lot of work on SyncML : Now, XML to WBXML encoding should work. 
      This must be tested a bit more, but it seems to work fine :)
    * testsuite/syncml/ : Some SyncML test files has been corrected.
    * src/wbxml_tables.c : SyncML Table has been corrected.
    * src/wbxml_tables.[c|h] : Added MetInf 1.0 Public ID 
      (thanks to Bo Lincoln)
    * Lot of Doxygen fixes

2003-10-17  Aymerick Jehanne <libwbxml@jehanne.org>
    * Refactored code:
      - Removed 'conv/' directory and moved code to 'src/'.
      - Added 'HAVE_EXPAT' compile flag.
      - Renamed some files, fonctions, etc...

2003-10-15  Aymerick Jehanne <libwbxml@jehanne.org>
    * src/wbxml_encoder.c : In parse_attribute(), return 'WBXML_OK'
      if there is no Attribute Table (ie: do not stop encoding).
      This is needed for SyncML.

2003-08-02  Aymerick Jehanne <libwbxml@jehanne.org>
    * New release of wbxml2: 0.7.3

2003-06-25  Aymerick Jehanne <libwbxml@jehanne.org>
    * src/wbxml.h, wbxml_encoder.[h|c], wbxml_parser.c, 
      wbxml_tables.[c|h] : Corrected SyncML WBXML Parsing and 
      SyncML XML Encoding.

2003-06-24  Aymerick Jehanne <libwbxml@jehanne.org>
    * src/wbxml_buffers.[c|h] : Added wbxml_buffer_compare_cstr()
    * src/wbxml_tree.[c|h] : Added a new Node Type 'WBXML_TREE_TREE_NODE'
      and the search function wbxml_tree_get_element_node_from_name()
    * src/wbxml_tree_clb.c : Handle parsing of SyncML encapsulated WBXML
      documents
    * src/wbxml_encoder.c : XML Encoding of encapsulated WBXML documents
    * src/wbxml_tables.h : Corrected DevInf 1.0 XML ID

2003-06-03  Aymerick Jehanne <libwbxml@jehanne.org>
    * testsuite/syncml, testsuite/testsuite.xml : Started a SyncML
    Test Suite. Only 4 documents seems to work... mMm... too bad :-/

2003-05-26  Aymerick Jehanne <libwbxml@jehanne.org>
    * conv/Makefile.am, tools/Makefile.am : Added WBXML_LANG_OTA_SETTINGS.
    * wbxml_tables.c : Removed bugs when XML Header is not fully filled
      (thanks to Nicolas Bougues).
    * tools/xml2wbxml_tool.c, tools/wbxml2xml_tool.c : Added support of
      stdin and stdout (thanks to Nicolas Bougues).

2003-05-23  Aymerick Jehanne <libwbxml@jehanne.org>
    * testsuite/ota, testsuite/testsuite.xml : Added OTA Settings
      Test Suite.
    * src/wbxml_parser.c, src/wbxml_encoder.c: Modified the way the lib
      handle WBXML Versions.
    * tools/wbxml2xml_tool.c : Added OTA Settings forcing support.

2003-05-22  Aymerick Jehanne <libwbxml@jehanne.org>
    * Added support of Ericsson / Nokia OTA Settings v7.0. Thanks
      to Nicolas Bougues for the hints.
    * src/wbxml.h : Added WBXML_LANG_OTA_SETTINGS.
    * src/wbxml_tables.[h|c] : Added tables for OTA Settings.
    * src/Makefile.am : Added WBXML_LANG_OTA_SETTINGS compilation flag.
    * INSTALL : Added documentation of WBXML_LANG_OTA_SETTINGS.
    * src/wbxml_tables.h : Added a true value for WBXML_PUBLIC_ID_WV_CSP11,
      as found at 'http://www.openmobilealliance.org/tech/omna/
      omna-wbxml-public-docid.htm'. XML Public ID is different too... maybe
      we have to switch to it... one day

2003-05-02  Aymerick Jehanne <libwbxml@jehanne.org>
    * Added compilation flag WBXML_ENCODER_USE_STRTBL. If not defined,
      the String Table mecanism is not used (but it is still used
      for unknown WBXML Public ID).

2003-05-01  Aymerick Jehanne <libwbxml@jehanne.org>
    * src/wbxml.h: Added a new enum 'WBXMLLanguage' to identify
      each language supported. So that we don't rely on WBXML Public
      ID (some languages doesn't have one).
    * src/wbxml_tables.[h|c]: Modified 'WBXMLLangEntry' structure to
      associate a 'WBXMLLanguage' for each language. Added a new
      function wbxml_tables_get_wbxml_publicid() to get the WBXML
      Public ID of a given Language.
    * src/wbxml_parser.[h|c]: 
        - Use the new 'WBXMLLanguage' enum.
        - Added a new parameter to wbxml_parser_parse_to_tree() to
      force to parse the document to a given Language.
        - Added wbxml_parser_set_language() that replaces the old
      wbxml_parser_set_wbxml_public_id().
        - Changed wbxml_parser_get_wbxml_public_id() and
      wbxml_parser_get_xml_public_id() behaviour.
    * src/wbxml_encoder.c: Use the new 'WBXMLLanguage' enum.
    * conv/wbxml_conv.h: Added the 'lang' parameter to 
      WBXML2XMLParameters structure.
    * conv/wbxml2xmlc.: Use wbxml_parser_set_language() in Direct Mode.
      Use the new parameter of wbxml_parser_parse_to_tree() in Tree Mode.
    * tools/wbxml2xml_tool.c: Added '-l' option so that the user can
      force parsing of document to a given Language.
    * win32/*.dsp, conv/Makefile.am, src/Makefile.am, tools/Makefile.am,
      tools/wbxml2xml_tool.c, src/wbxml.h, src/wbxml_errors.h,
      src/wbxml_log.h, src/wbxml_encoder.c, src/wbxml_errors.c,
      src/wbxml_log.c, wbxml_parser.c, wbxml_tables.c: Added compilation
      flags for selecting supported languages.

2003-04-30  Aymerick Jehanne <libwbxml@jehanne.org>
    * src/wbxml.h : Added #pragma for WIN32 plateform, so that
      some hidden warnings generate errors. Thanks to Ramki for
      it's ARM compilation support ;)
    * src/*, conv/*, tools/* : Modified numerous files to
      correct this 'new' errors. Modified some structures (mainly
      in 'src/wbxml_tables.h', and added some macro for automatic
      casts so that we don't have to modify the API. Most of the
      modifications concern WB_TINY to WB_UTINY casts.

2003-04-26  Aymerick Jehanne <libwbxml@jehanne.org>
    * New release of wbxml2: 0.7.2

2003-04-26  Aymerick Jehanne <libwbxml@jehanne.org>
    * src/wbxml.h: Casted strlen(), strdup(), strcmp(), strncmp()
      and strstr() parameters to (const char*) in macros.
    * src/wbxml_tables.[h|c]: Added function 
      wbxml_tables_contains_attr_value_from_xml()
    * wbxml_encoder.c: 
        - Changed WBXML_ENCODER_STRING_TABLE_MIN to '3'.
        - In wbxml_strtbl_collect_strings(): check if the attribute
          value is tokenisable before adding it to string table.
        - In wbxml_encode_value_element_buffer(): corrected a bug 
          when splitting the buffer for String Table elements

2003-04-25  Aymerick Jehanne <libwbxml@jehanne.org>
    * testsuite/prov: Added OMA Prov 1.0 Test Suite
    * src/wbxml_tables.c: Updated Prov 1.0 tables 
      (added new OMA elements / attributes)
    * src/wbxml_encoder.c: Ignore blanks Text Node when building
      String Table

2003-04-24  Aymerick Jehanne <libwbxml@jehanne.org>
    * Changed 'CR-LF' to 'LF' in all source files and Makefiles.
      This should permits Linux users to compile normally.
      Thanks to Jannes Faber for finding this solution.

2003-04-19  Aymerick Jehanne <libwbxml@jehanne.org>
    * Added Parsing of WV DateTime - Encoding not yet finished
    * src/wbxml_tables.c : wbxml_tables_get_attr_from_xml() - check if
      attr table is NULL ... thanx to Bo Lincoln

2003-03-26  Aymerick Jehanne <libwbxml@jehanne.org>
    * wbxml_encoder.c, wbxml_tables.c: More work on WV. Now Extension
      tokens are generated, even while encoding simple String.

2003-03-25  Aymerick Jehanne <libwbxml@jehanne.org>
    * wbxml_errors.[h|c]: Added 'WBXML_NOT_ENCODED' and 
      'WBXML_ERROR_WV_INTEGER_OVERFLOW' error codes.
    * wbxml_encoder.c: Added wbxml_encode_wv_content() and
      wbxml_encode_wv_integer() functions. Now WV Integers are encoded
      correctly.
    * wbxml.h: Added 'enum WBXMLWVDataType_e', that is used in Encoder
      and in Parser.
    * wbxml_tables.[h|c]: Added wbxml_tables_get_ext_from_xml() to
      get an Extension Token from tables.
    * wbxml_parser.c: Added decode_opaque_content() and
      decode_wv_integer(). Now WV Integers are decoded correctly.
    
2003-03-24  Aymerick Jehanne <libwbxml@jehanne.org>
    * wbxml_tables.[c|h]: wbxml_tables_get_attr_from_xml(): modified for
      better behaviour. Now it returns the attribute value part that is
      not included in Attribute Token returns.
    * wbxml_encoder.c: Now use wbxml_tables_get_tag_from_xml() and
      wbxml_tables_get_attr_from_xml().
    * conv/xml2wbxml_clb.c: Modification due to changes of
      wbxml_tables_get_attr_from_xml() prototype.

2003-03-23  Aymerick Jehanne <libwbxml@jehanne.org>
    * wbxml_tables.[h|c]: Added Wireless-Village 1.2 tokens. This is taken
      from a Beta spec from OMA that contains some bugs. Hope this will be
      corrected in next release of the spec. Corrected XML Public ID and
      DTD of OMA WV 1.1. 
    * wbxml_tables.c: Added macro WBXML_TABLES_SEPARATE_WML_VERSIONS. 
      If undefined, only WML 1.3 tables are used, for all versions of WML.
    * testsuite/wv: Corrected for OMA WV 1.1

2003-03-22  Aymerick Jehanne <libwbxml@jehanne.org>
    * Added 'testsuite/emn': E-Mail Notification 1.0 Test Suite
    * src/wbxml_encoder.c, src/wbxml_parser.c: Added encoding/decoding
      of EMN 1.0 'timestamp' attribute

2003-03-21  Aymerick Jehanne <libwbxml@jehanne.org>
    * New release of wbxml2: 0.7.1

2003-03-20  Aymerick Jehanne <libwbxml@jehanne.org>
    * Added /doc directory, with Docbook file and generated HTML
    * Added /web directory, with the few website files
    * Worked with Pau Alliagas on Linux port
    
2003-03-19  Aymerick Jehanne <libwbxml@jehanne.org>
    * Review the header files include mecanism
    * Debug

2003-03-17  Aymerick Jehanne <libwbxml@jehanne.org>
    * Added Encoding/Decoding of SI %Datetime Attribute Values
    * Added /testsuite/testsuite.xml Index File
    * Added /testsuite/si/si-022.xml, /testsuite/si/si-023.xml,
            /testsuite/si/si-024.xml, /testsuite/si/si-025.xml

2003-03-16  Aymerick Jehanne <libwbxml@jehanne.org>
    * New 'wbxml2' branch. A lot of changes:
        - Now, we have two libraries:
            - libwbxml2 (standalone)
            - libwbxml2_conv (needs libwbxml2 and Expat libraries)
        - A new representation of WBXML Document: The WBXMLTree
        - Review of tokenisation of Attribute Values
        - etc...
    * The Makefile for wbxml2xml and xml2wbxml tools is not finished

2003-02-21  Aymerick Jehanne <libwbxml@jehanne.org>
    * src/Makefile.am: Removed definition of WBXML_LIB_VERBOSE,
      replaced by the '-DWBXML_LIB_VERBOSE' CFLAG in src/Makefile.am
      (thanks to Pau Aliagas)

2003-02-03  Aymerick Jehanne <libwbxml@jehanne.org>
    * wbxml_tables.c: Fixed "WVCSPFeat" attribute
    * bootstrap: chmoded correctly

2003-01-28  Aymerick Jehanne <libwbxml@jehanne.org>
    * New release v0.6.1 (not yet packaged)
    
2003-01-27  Pau Aliagas <pau@smsarena.com>
    * Adapt to autotools
    * Build dynamic library
    * Create a spec file for rpm
    
2003-01-25  Aymerick Jehanne <libwbxml@jehanne.org>
    * wbxml_tables.c: Removed a bug in 'sv_prov10_attr_table'.
      Thanks to Pau Aliagas.
    * src/wbxml_parser.c and test/parser_clb.c: Removed a bug
      with empty attribute value.     

2002-12-08  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * New release v0.6

2002-12-08  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * wbxml_parser.c : Removed bug when parsing Literal Tag
    * wbxml_buffers.c : Removed bug in wbxml_buffer_create()
    * wbxml_encoder.c : Now encode Literal Attribut Names and Tags
    * Added Leak Tracker Support in several files
    * Redone a new 'makefile' (still needs 'configure' to searche for LibXML2)

2002-12-07  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Added wbxml_lists.[h|c]: List module needed by String Table handling in
    wbxml_encoder.c.
    * Added support of String Table in WBXML Encoder (still needs testing)
    * Still needs:
        - Apply String Table to attribute values
        - Handle Literal tags and Attribute Names

2002-12-04  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Changed the Log Mecanism: Added Macros with variable parameters number
    
2002-12-01  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * More work on Wireless-Village CSP

2002-11-24  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Added first version of WBXML Encoder... not really tested yet
    * Todo in WBXML Encoder:
        - Remove Ignorable XML Whitespaces before parsing
        - Handle String Table
        - Parse CDDATA
        - Parse PI
        - Encode Literal tags and Literal attribute names
        - Correctly encode the attribute values (not only as Inline Strings)
        - Handle Charsets Encoding    

2002-11-14  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Commited Benedykt Kroplewski modifications

2002-11-11 Benedykt Kroplewski <benedykt@age.pl>
    * Correct simple lenght variable bug in wbxml lib and parser
    * Correct macros for compile with my Slackware linux...
    * Make more detailed debug messages...
    * Added SyncMl 1.0 definitions...(my phone use it)

2002-11-11  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Reorganized DLLs to start coding of a WBXML Encoder:
        - wbxml_common: Common WBXML Functions
        - wbxml_parser: WBXML Parser
        - wbxml_encoder: WBXML Encoder
    * wbxml_tables.c: New function wbxml_table_get_main() to get pointer on main WBXML Languages Table
    * wbxml_parser.c: Modified to use wbxml_table_get_main()
    * New files wbxml_encoder.[h|c]: nothing inside for now
    * Removed file wbxml_types.h => moved into new file wbxml.h
    * New magic macro "WBXML_DECLARE" for automatic DLL export under Windows, so lot of files has been
      updated to use this macro

2002-09-22  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Added a best effort mode (WBXML_PARSER_BEST_EFFORT define).
    * New release v0.5

2002-09-08  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Removed bug in parse_attr_start() for 'attrCodePage' search.

2002-08-16  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Changed a stupid logic in wbxml_buffers.c for memory management (gosh)

2002-08-15  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Changed all Tabs to '4 spaces'
    * Changed root element of WTA WML 1.2 to 'wta-wml'
    * Changed 'Channel 1.2' token from 0x0D to 0x0E. I don't really understand if Channel 1.2 Public ID
      is "-//WAPFORUM//DTD DLREL 1.0//EN" or "-//WAPFORUM//DTD CHANNEL 1.2//EN" 
      (http://www.wapforum.org/wina/wbxml-public-docid.htm)
    * Added Token an Attribute tables for Wireless Village CSP 1.1, but it's not really usefull, because
      there is no PublicID defined for it. I have to implement support of Extension Tokens for CSP 1.1 too...
      but... well... why have they defined use of Extension Tokens instead of normal Attribute Value Table ??

2002-08-03  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Enum and Struct naming clean-up
    * Added "NULL" line in sv_table_entry to avoid crash if publicId not found.
    * New release v0.4

2002-07-13  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Makefile for Linux done (only tested with Cygwin)    
    * src/wbxml_parser.c: Removed duplicate WBXMLParser Typedef (Linux Error generated)
    * test/parser_tester.c: Changed main() argv parameter type (Linux Warning generated)
    * Added a WBXML Test File
    * Making release v0.3

2002-06-29  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Making release v0.2

2002-06-29  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Added a Windows GUI. It seems to work.. it's late... and i go to bed... 

2002-06-28  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Added 'extern "C"' in *.h files, so that we can use the library
      in a C++ program.

2002-06-19  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * Ho yes ! Now wbxmllib is accessible via SourceForge ! =)

2002-06-15  Aymerick Jehanne <wbxml_lib@jehanne.org>
    * First release of WBXML Library (v0.1) under LGPL 2.1
      It contains a WBXML Parser, with a SAX like interface.
      
      Known issues:
      	- Support of Charsets not fully implemented (we assume that strings
      	  are NULL terminated).
      	- Only tested with WML Content.
